// *************************************
//Website:  http://wch.cn
//Email:    tech@wch.cn
//Author:   W.ch 2006.4
// *************************************

#include <reg52.h>
#include <intrins.h>

#include "CH450IF.H"	// ޸ĸļӦӲ/Ƭͺŵ

unsigned char CH450_buf[6];                 //6ܵӳ󻺴
const unsigned char BCD_decode_tab[0x10] = { 0X3F, 0X06, 0X5B, 0X4F, 0X66, 0X6D, 0X7D, 0X07, 0X7F, 0X6F, 0X77, 0X7C, 0X58, 0X5E, 0X79, 0X71 };

void	mDelaymS( unsigned char ms )     // ʱ
{
	unsigned short i;
	while ( ms -- ) {
		for(i=0;i!=1000;i++);
	}
}

void	mDelayS( unsigned char s )      // ʱ
{
	while ( s -- ) 
	{	mDelaymS( 250 );
		mDelaymS( 250 );
		mDelaymS( 250 );
		mDelaymS( 250 );
	}
}

void	CH450_buf_write( unsigned short cmd )  // CH450ݻ߲,Զӳ
{
	if ( cmd & 0x1000 ) {   // ݵ,Ҫݵӳ󻺳
		CH450_buf[ (unsigned char)( ( cmd >> 8 ) - 2 ) & 0x07 ] = (unsigned char)( cmd & 0xFF );	// ݵӦӳԪ
	}
	CH450_Write( cmd );	// 
}

void	CH450_buf_index( unsigned char index, unsigned char dat )  // CH450ָ,Զӳ
// index Ϊ,ЧֵΪ05,ֱӦDIG2DIG7
{
	unsigned short cmd;
	CH450_buf[ index ] = dat;	// ݵӦӳԪ
	cmd = ( CH450_DIG2 + ( (unsigned short)index << 8 ) ) | dat ;	// ɲ
	CH450_Write( cmd );	// 
}

void CH450_set_bit(unsigned char bit_addr)     //λ
{
	unsigned char byte_addr;
	byte_addr=(bit_addr&0x38)>>3;
	if ( byte_addr < 6 ) CH450_buf_index( byte_addr, CH450_buf[byte_addr] | (1<<(bit_addr&0x07)) );
}

void CH450_clr_bit(unsigned char bit_addr)     //λϨ
{
	unsigned char byte_addr;
	byte_addr=(bit_addr&0x38)>>3;
	if ( byte_addr < 6 ) CH450_buf_index( byte_addr, CH450_buf[byte_addr] & ~(1<<(bit_addr&0x07)) );
}

main()
{
	unsigned char i, j;
	mDelaymS( 50 );
	for ( i = 0; i < 6; i ++ ) CH450_buf_index( i, 0 );  // ΪCH450λʱʾݣԸտΪգٿʾ
	CH450_buf_write(CH450_SYSON1);	// ʾ
// ҪˢʾݣôֻҪִ76ݼԼ1ʾ
	CH450_buf_write(CH450_DIG7 | BCD_decode_tab[1]);	// ʾBCD1
	CH450_buf_write(CH450_DIG6 | BCD_decode_tab[2]);
	CH450_buf_write(CH450_DIG5 | BCD_decode_tab[3]);
	CH450_buf_write(CH450_DIG4 | BCD_decode_tab[4]);
	CH450_buf_write(CH450_DIG3 | BCD_decode_tab[5]);
	CH450_buf_write(CH450_DIG2 | BCD_decode_tab[6]);
	while ( 1 ) {  // ʾ
		for( i=0; i<6; i++ ) CH450_buf_index( i, 0xFF );  // ȫ
		mDelayS(1);
		for( i=0; i<6; i++ ) CH450_buf_index( i, 0x00 );  // ȫ
		mDelayS(1);
		for ( j = 0; j != 8; j ++ ) {  // ɨÿΣʾ
			for ( i = 0; i != 6; i ++ ) CH450_buf_index( i, 1<<j );
			mDelaymS( 250 );
			mDelaymS( 250 );
		}
		for( i=0; i<6; i++ ) CH450_buf_index( i, 0xFF );  // ȫ
		mDelayS(1);
		for( i=0; i<6; i++ ) CH450_buf_index( i, BCD_decode_tab[i] );  // ʾBCD012345
		mDelayS(1);
		for( i=0; i<6; i++ ) CH450_buf_index( i, BCD_decode_tab[i+6] );  // ʾBCD6789ab
		mDelayS(1);
		for( i=0; i<6; i++ ) CH450_buf_index( i, 0x00 );  // ȫ
		mDelayS(1);
		for(i=0;i!=6*8;i++) {  // öλ
			CH450_set_bit(i);
			mDelaymS(200);
		}
		mDelayS(1);
		for(i=0;i!=6*8;i++) {  // λ
			CH450_clr_bit(i);
			mDelaymS(200);
		}
		mDelayS(1);
	}
}
